diff --git a/src/cursor/cur_std.c b/src/cursor/cur_std.c
index 0c7bbfb6f..3407562c7 100644
--- a/src/cursor/cur_std.c
+++ b/src/cursor/cur_std.c
@@ -808,28 +808,34 @@ __wt_cursor_cache_get(WT_SESSION_IMPL *session, const char *uri, uint64_t hash_v
          * for configurations that only differ by a cursor flag, which we can patch up if we find a
          * matching cursor.
          */
-        WT_RET(__wt_config_gets_def(session, cfg, "bulk", 0, &cval));
+        WT_RET(__wt_config_gets_def_api(
+          session, cfg, WT_API_SESSION_OPEN_CURSOR_BULK, "bulk", 0, &cval));
         if (cval.val)
             return (WT_NOTFOUND);
 
-        WT_RET(__wt_config_gets_def(session, cfg, "debug", 0, &cval));
+        WT_RET(__wt_config_gets_def_api(
+          session, cfg, WT_API_SESSION_OPEN_CURSOR_DEBUG, "debug", 0, &cval));
         if (cval.len != 0)
             return (WT_NOTFOUND);
 
-        WT_RET(__wt_config_gets_def(session, cfg, "dump", 0, &cval));
+        WT_RET(__wt_config_gets_def_api(
+          session, cfg, WT_API_SESSION_OPEN_CURSOR_DUMP, "dump", 0, &cval));
         if (cval.len != 0)
             return (WT_NOTFOUND);
 
-        WT_RET(__wt_config_gets_def(session, cfg, "next_random", 0, &cval));
+        WT_RET(__wt_config_gets_def_api(
+          session, cfg, WT_API_SESSION_OPEN_CURSOR_NEXT_RANDOM, "next_random", 0, &cval));
         if (cval.val != 0)
             return (WT_NOTFOUND);
 
-        WT_RET(__wt_config_gets_def(session, cfg, "readonly", 0, &cval));
+        WT_RET(__wt_config_gets_def_api(
+          session, cfg, WT_API_SESSION_OPEN_CURSOR_READONLY, "readonly", 0, &cval));
         if (cval.val)
             return (WT_NOTFOUND);
 
         /* Checkpoints are readonly, we won't cache them. */
-        WT_RET(__wt_config_gets_def(session, cfg, "checkpoint", 0, &cval));
+        WT_RET(__wt_config_gets_def_api(
+          session, cfg, WT_API_SESSION_OPEN_CURSOR_CHECKPOINT, "checkpoint", 0, &cval));
         if (cval.val)
             return (WT_NOTFOUND);
     }
@@ -872,21 +878,25 @@ __wt_cursor_cache_get(WT_SESSION_IMPL *session, const char *uri, uint64_t hash_v
                  * The append flag is only relevant to column stores.
                  */
                 if (WT_CURSOR_RECNO(cursor)) {
-                    WT_RET(__wt_config_gets_def(session, cfg, "append", 0, &cval));
+                    WT_RET(__wt_config_gets_def_api(
+                      session, cfg, WT_API_SESSION_OPEN_CURSOR_APPEND, "append", 0, &cval));
                     if (cval.val != 0)
                         F_SET(cursor, WT_CURSTD_APPEND);
                 }
 
-                WT_RET(__wt_config_gets_def(session, cfg, "overwrite", 1, &cval));
+                WT_RET(__wt_config_gets_def_api(
+                  session, cfg, WT_API_SESSION_OPEN_CURSOR_OVERWRITE, "overwrite", 1, &cval));
                 if (cval.val == 0)
                     F_CLR(cursor, WT_CURSTD_OVERWRITE);
 
-                WT_RET(__wt_config_gets_def(session, cfg, "raw", 0, &cval));
+                WT_RET(__wt_config_gets_def_api(
+                  session, cfg, WT_API_SESSION_OPEN_CURSOR_RAW, "raw", 0, &cval));
                 if (cval.val != 0)
                     F_SET(cursor, WT_CURSTD_RAW);
 
                 if (cbt) {
-                    WT_RET(__wt_config_gets_def(session, cfg, "read_once", 0, &cval));
+                    WT_RET(__wt_config_gets_def_api(
+                      session, cfg, WT_API_SESSION_OPEN_CURSOR_READ_ONCE, "read_once", 0, &cval));
                     if (cval.val != 0)
                         F_SET(cbt, WT_CBT_READ_ONCE);
                 }
@@ -1220,7 +1230,8 @@ __wt_cursor_init(
      * append The append flag is only relevant to column stores.
      */
     if (WT_CURSOR_RECNO(cursor)) {
-        WT_RET(__wt_config_gets_def(session, cfg, "append", 0, &cval));
+        WT_RET(__wt_config_gets_def_api(
+          session, cfg, WT_API_SESSION_OPEN_CURSOR_APPEND, "append", 0, &cval));
         if (cval.val != 0)
             F_SET(cursor, WT_CURSTD_APPEND);
     }
@@ -1231,11 +1242,13 @@ __wt_cursor_init(
      */
     readonly = F_ISSET(S2C(session), WT_CONN_READONLY);
     if (!readonly) {
-        WT_RET(__wt_config_gets_def(session, cfg, "checkpoint", 0, &cval));
+        WT_RET(__wt_config_gets_def_api(
+          session, cfg, WT_API_SESSION_OPEN_CURSOR_CHECKPOINT, "checkpoint", 0, &cval));
         readonly = cval.len != 0;
     }
     if (!readonly) {
-        WT_RET(__wt_config_gets_def(session, cfg, "readonly", 0, &cval));
+        WT_RET(__wt_config_gets_def_api(
+          session, cfg, WT_API_SESSION_OPEN_CURSOR_READONLY, "readonly", 0, &cval));
         readonly = cval.val != 0;
     }
     if (readonly) {
@@ -1253,7 +1266,8 @@ __wt_cursor_init(
      * with the dump config string, and with the index cursor as an owner. We don't want to create a
      * dump cursor in that case, because we'll create the dump cursor on the index cursor itself.
      */
-    WT_RET(__wt_config_gets_def(session, cfg, "dump", 0, &cval));
+    WT_RET(
+      __wt_config_gets_def_api(session, cfg, WT_API_SESSION_OPEN_CURSOR_DUMP, "dump", 0, &cval));
     if (cval.len != 0 && owner == NULL) {
         uint32_t dump_flag;
         if (WT_STRING_MATCH("json", cval.str, cval.len))
@@ -1278,14 +1292,15 @@ __wt_cursor_init(
         cdump = NULL;
 
     /* overwrite */
-    WT_RET(__wt_config_gets_def(session, cfg, "overwrite", 1, &cval));
+    WT_RET(__wt_config_gets_def_api(
+      session, cfg, WT_API_SESSION_OPEN_CURSOR_OVERWRITE, "overwrite", 1, &cval));
     if (cval.val)
         F_SET(cursor, WT_CURSTD_OVERWRITE);
     else
         F_CLR(cursor, WT_CURSTD_OVERWRITE);
 
     /* raw */
-    WT_RET(__wt_config_gets_def(session, cfg, "raw", 0, &cval));
+    WT_RET(__wt_config_gets_def_api(session, cfg, WT_API_SESSION_OPEN_CURSOR_RAW, "raw", 0, &cval));
     if (cval.val != 0)
         F_SET(cursor, WT_CURSTD_RAW);
 
diff --git a/src/include/api.h b/src/include/api.h
index 892972e28..5a3e0907e 100644
--- a/src/include/api.h
+++ b/src/include/api.h
@@ -37,19 +37,22 @@
 #define API_SESSION_PUSH(s, h, n, dh)                                                        \
     WT_DATA_HANDLE *__olddh = (s)->dhandle;                                                  \
     const char *__oldname;                                                                   \
+    u_int __oldmethodid;                                                                     \
     /* If this isn't an API reentry, the name should be NULL and the counter should be 0. */ \
     WT_ASSERT(s, (s)->name != NULL || (s)->api_call_counter == 0);                           \
     __oldname = (s)->name;                                                                   \
     ++(s)->api_call_counter;                                                                 \
     (s)->dhandle = (dh);                                                                     \
-    (s)->name = (s)->lastop = #h "." #n
-#define API_SESSION_POP(s)  \
-    (s)->dhandle = __olddh; \
-    (s)->name = __oldname;  \
+    (s)->name = (s)->lastop = #h "." #n;                                                     \
+    __oldmethodid = (s)->api_method_id
+#define API_SESSION_POP(s)              \
+    (s)->dhandle = __olddh;             \
+    (s)->name = __oldname;              \
+    (s)->api_method_id = __oldmethodid; \
     --(s)->api_call_counter
 
 /* Standard entry points to the API: declares/initializes local variables. */
-#define API_SESSION_INIT(s, h, n, dh)                                   \
+#define API_SESSION_INIT(s, h, n, dh, m)                                \
     WT_TRACK_OP_DECL;                                                   \
     API_SESSION_PUSH(s, h, n, dh);                                      \
     /*                                                                  \
@@ -64,16 +67,17 @@
     /* Reset wait time if this isn't an API reentry. */                 \
     if ((s)->api_call_counter == 1)                                     \
         (s)->cache_wait_us = 0;                                         \
+    (s)->api_method_id = m;                                             \
     __wt_verbose((s), WT_VERB_API, "%s", "CALL: " #h ":" #n)
 
 #define API_CALL_NOCONF(s, h, n, dh) \
     do {                             \
-    API_SESSION_INIT(s, h, n, dh)
+    API_SESSION_INIT(s, h, n, dh, 0)
 
 #define API_CALL(s, h, n, dh, config, cfg)                                \
     do {                                                                  \
         const char *(cfg)[] = {WT_CONFIG_BASE(s, h##_##n), config, NULL}; \
-        API_SESSION_INIT(s, h, n, dh);                                    \
+        API_SESSION_INIT(s, h, n, dh, WT_API_##h##_##n);                  \
         if ((config) != NULL)                                             \
     WT_ERR(__wt_config_check((s), WT_CONFIG_REF(s, h##_##n), (config), 0))
 
diff --git a/src/include/compiled_inline.h b/src/include/compiled_inline.h
new file mode 100644
index 000000000..c80ee8812
--- /dev/null
+++ b/src/include/compiled_inline.h
@@ -0,0 +1,30 @@
+/*-
+ * Copyright (c) 2014-present MongoDB, Inc.
+ * Copyright (c) 2008-2014 WiredTiger, Inc.
+ *	All rights reserved.
+ *
+ * See the file LICENSE for redistribution information.
+ */
+
+/*
+ * __wt_compiled_has --
+ *     Return true if the configuration string has the api tag.
+ */
+static inline bool
+__wt_compiled_has(WT_CONNECTION_IMPL *conn, const char *config, int api)
+{
+    uint64_t bit;
+
+    bit = (uint64_t)(1 << api);
+    return ((conn->compiled_array[(config - conn->compiled_config_str)]->set & bit) != 0);
+}
+
+/*
+ * __wt_is_compiled_config --
+ *     Return true if the configuration string has been compiled.
+ */
+static inline bool
+__wt_is_compiled_config(WT_CONNECTION_IMPL *conn, const char *config)
+{
+    return (config >= conn->compiled_config_str && config <= conn->compiled_config_current);
+}
diff --git a/src/include/config.h b/src/include/config.h
index 29c576def..0d410d39b 100644
--- a/src/include/config.h
+++ b/src/include/config.h
@@ -16,6 +16,12 @@ struct __wt_config {
     const int8_t *go;
 };
 
+#define WT_CONFIG_COMPILED_TYPE_INT 0
+#define WT_CONFIG_COMPILED_TYPE_BOOLEAN 1
+#define WT_CONFIG_COMPILED_TYPE_STRING 2
+#define WT_CONFIG_COMPILED_TYPE_CATEGORY 3
+#define WT_CONFIG_COMPILED_TYPE_LIST 4
+
 struct __wt_config_check {
     const char *name;
     const char *type;
@@ -23,6 +29,8 @@ struct __wt_config_check {
     const char *checks;
     const WT_CONFIG_CHECK *subconfigs;
     u_int subconfigs_entries;
+    u_int compiled_type;
+    u_int compiled_offset;
 };
 
 #define WT_CONFIG_REF(session, n) (S2C(session)->config_entries[WT_CONFIG_ENTRY_##n])
@@ -34,6 +42,8 @@ struct __wt_config_entry {
 
     const WT_CONFIG_CHECK *checks; /* check array */
     u_int checks_entries;
+    u_int method_id;
+    bool compilable;
 };
 
 struct __wt_config_parser_impl {
diff --git a/src/include/connection.h b/src/include/connection.h
index f361eb283..a345831a8 100644
--- a/src/include/connection.h
+++ b/src/include/connection.h
@@ -519,6 +519,16 @@ struct __wt_connection_impl {
 
     void *lang_private; /* Language specific private storage */
 
+    /* Compiled configuration */
+    char *compiled_config_str; /* Dummy strings used by caller */
+    char *compiled_config_current;
+    WT_COMPILED **compiled_array;
+    uint32_t compiled_cnt;         /* Items in compiled array */
+    uint32_t compiled_session_cnt; /* Items reserved in session array */
+    size_t compiled_size;          /* Size of compiled array */
+    size_t compiled_max;           /* Maximum size of compiled array */
+    size_t compiled_unbound_cnt;
+
     /* If non-zero, all buffers used for I/O will be aligned to this. */
     size_t buffer_alignment;
 
diff --git a/src/include/extern.h b/src/include/extern.h
index 5a05b6c14..c236e1668 100644
--- a/src/include/extern.h
+++ b/src/include/extern.h
@@ -399,6 +399,12 @@ extern int __wt_collator_config(WT_SESSION_IMPL *session, const char *uri, WT_CO
   WT_CONFIG_ITEM *metadata, WT_COLLATOR **collatorp, int *ownp)
   WT_GCC_FUNC_DECL_ATTRIBUTE((warn_unused_result));
 extern int __wt_compact(WT_SESSION_IMPL *session) WT_GCC_FUNC_DECL_ATTRIBUTE((warn_unused_result));
+extern int __wt_compiled_bind(WT_SESSION_IMPL *session, const char *compiled_str,
+  const char **bound_str, va_list ap) WT_GCC_FUNC_DECL_ATTRIBUTE((warn_unused_result));
+extern int __wt_compiled_config_init(WT_SESSION_IMPL *session, const char **cfg)
+  WT_GCC_FUNC_DECL_ATTRIBUTE((warn_unused_result));
+extern int __wt_compiled_get(WT_SESSION_IMPL *session, int api, const char *compiled_str,
+  WT_CONFIG_ITEM *value) WT_GCC_FUNC_DECL_ATTRIBUTE((warn_unused_result));
 extern int __wt_compressor_config(WT_SESSION_IMPL *session, WT_CONFIG_ITEM *cval,
   WT_COMPRESSOR **compressorp) WT_GCC_FUNC_DECL_ATTRIBUTE((warn_unused_result));
 extern int __wt_cond_auto_alloc(WT_SESSION_IMPL *session, const char *name, uint64_t min,
@@ -409,6 +415,8 @@ extern int __wt_config_collapse(WT_SESSION_IMPL *session, const char **cfg, char
   WT_GCC_FUNC_DECL_ATTRIBUTE((warn_unused_result));
 extern int __wt_config_get(WT_SESSION_IMPL *session, const char **cfg_arg, WT_CONFIG_ITEM *key,
   WT_CONFIG_ITEM *value) WT_GCC_FUNC_DECL_ATTRIBUTE((warn_unused_result));
+extern int __wt_config_get_api(WT_SESSION_IMPL *session, const char **cfg_arg, int api,
+  WT_CONFIG_ITEM *key, WT_CONFIG_ITEM *value) WT_GCC_FUNC_DECL_ATTRIBUTE((warn_unused_result));
 extern int __wt_config_getone(WT_SESSION_IMPL *session, const char *config, WT_CONFIG_ITEM *key,
   WT_CONFIG_ITEM *value) WT_GCC_FUNC_DECL_ATTRIBUTE((warn_unused_result));
 extern int __wt_config_getones(WT_SESSION_IMPL *session, const char *config, const char *key,
@@ -417,8 +425,12 @@ extern int __wt_config_getones_none(WT_SESSION_IMPL *session, const char *config
   WT_CONFIG_ITEM *value) WT_GCC_FUNC_DECL_ATTRIBUTE((warn_unused_result));
 extern int __wt_config_gets(WT_SESSION_IMPL *session, const char **cfg, const char *key,
   WT_CONFIG_ITEM *value) WT_GCC_FUNC_DECL_ATTRIBUTE((warn_unused_result));
+extern int __wt_config_gets_api(WT_SESSION_IMPL *session, const char **cfg, int api,
+  const char *key, WT_CONFIG_ITEM *value) WT_GCC_FUNC_DECL_ATTRIBUTE((warn_unused_result));
 extern int __wt_config_gets_def(WT_SESSION_IMPL *session, const char **cfg, const char *key,
   int def, WT_CONFIG_ITEM *value) WT_GCC_FUNC_DECL_ATTRIBUTE((warn_unused_result));
+extern int __wt_config_gets_def_api(WT_SESSION_IMPL *session, const char **cfg, int api,
+  const char *key, int def, WT_CONFIG_ITEM *value) WT_GCC_FUNC_DECL_ATTRIBUTE((warn_unused_result));
 extern int __wt_config_gets_none(WT_SESSION_IMPL *session, const char **cfg, const char *key,
   WT_CONFIG_ITEM *value) WT_GCC_FUNC_DECL_ATTRIBUTE((warn_unused_result));
 extern int __wt_config_merge(WT_SESSION_IMPL *session, const char **cfg, const char *cfg_strip,
@@ -445,6 +457,8 @@ extern int __wt_conn_cache_pool_open(WT_SESSION_IMPL *session)
   WT_GCC_FUNC_DECL_ATTRIBUTE((warn_unused_result));
 extern int __wt_conn_compat_config(WT_SESSION_IMPL *session, const char **cfg, bool reconfig)
   WT_GCC_FUNC_DECL_ATTRIBUTE((warn_unused_result));
+extern int __wt_conn_compile_configuration(WT_SESSION_IMPL *session, const char *method,
+  const char *str, const char **compiled_str) WT_GCC_FUNC_DECL_ATTRIBUTE((warn_unused_result));
 extern int __wt_conn_config_init(WT_SESSION_IMPL *session)
   WT_GCC_FUNC_DECL_ATTRIBUTE((warn_unused_result));
 extern int __wt_conn_dhandle_alloc(WT_SESSION_IMPL *session, const char *uri,
@@ -1701,6 +1715,8 @@ extern void __wt_checkpoint_signal(WT_SESSION_IMPL *session, wt_off_t logsize);
 extern void __wt_checkpoint_tree_reconcile_update(WT_SESSION_IMPL *session, WT_TIME_AGGREGATE *ta);
 extern void __wt_ckpt_verbose(WT_SESSION_IMPL *session, WT_BLOCK *block, const char *tag,
   const char *ckpt_name, const uint8_t *ckpt_string, size_t ckpt_size);
+extern void __wt_compiled_bound_free(WT_SESSION_IMPL *session);
+extern void __wt_compiled_config_discard(WT_SESSION_IMPL *session);
 extern void __wt_cond_auto_wait(
   WT_SESSION_IMPL *session, WT_CONDVAR *cond, bool progress, bool (*run_func)(WT_SESSION_IMPL *));
 extern void __wt_cond_auto_wait_signal(WT_SESSION_IMPL *session, WT_CONDVAR *cond, bool progress,
@@ -1909,6 +1925,8 @@ static inline bool __wt_cache_stuck(WT_SESSION_IMPL *session)
   WT_GCC_FUNC_DECL_ATTRIBUTE((warn_unused_result));
 static inline bool __wt_checksum_match(const void *chunk, size_t len, uint32_t v)
   WT_GCC_FUNC_DECL_ATTRIBUTE((warn_unused_result));
+static inline bool __wt_compiled_has(WT_CONNECTION_IMPL *conn, const char *config, int api)
+  WT_GCC_FUNC_DECL_ATTRIBUTE((warn_unused_result));
 static inline bool __wt_eviction_clean_needed(WT_SESSION_IMPL *session, double *pct_fullp)
   WT_GCC_FUNC_DECL_ATTRIBUTE((warn_unused_result));
 static inline bool __wt_eviction_dirty_needed(WT_SESSION_IMPL *session, double *pct_fullp)
@@ -1919,6 +1937,8 @@ static inline bool __wt_eviction_updates_needed(WT_SESSION_IMPL *session, double
   WT_GCC_FUNC_DECL_ATTRIBUTE((warn_unused_result));
 static inline bool __wt_failpoint(WT_SESSION_IMPL *session, uint64_t conn_flag, u_int probability)
   WT_GCC_FUNC_DECL_ATTRIBUTE((warn_unused_result));
+static inline bool __wt_is_compiled_config(WT_CONNECTION_IMPL *conn, const char *config)
+  WT_GCC_FUNC_DECL_ATTRIBUTE((warn_unused_result));
 static inline bool __wt_isalnum(u_char c) WT_GCC_FUNC_DECL_ATTRIBUTE((warn_unused_result));
 static inline bool __wt_isalpha(u_char c) WT_GCC_FUNC_DECL_ATTRIBUTE((warn_unused_result));
 static inline bool __wt_isascii(u_char c) WT_GCC_FUNC_DECL_ATTRIBUTE((warn_unused_result));
diff --git a/src/include/session.h b/src/include/session.h
index b5a7479f7..a8e756997 100644
--- a/src/include/session.h
+++ b/src/include/session.h
@@ -72,6 +72,7 @@ struct __wt_session_impl {
     uint64_t operation_start_us;   /* Operation start */
     uint64_t operation_timeout_us; /* Maximum operation period before rollback */
     u_int api_call_counter;        /* Depth of api calls */
+    u_int api_method_id;           /* Method id, for compiled configuration */
 
     WT_DATA_HANDLE *dhandle;           /* Current data handle */
     WT_BUCKET_STORAGE *bucket_storage; /* Current bucket storage and file system */
@@ -146,6 +147,8 @@ struct __wt_session_impl {
     u_int ckpt_handle_next;       /* Next empty slot */
     size_t ckpt_handle_allocated; /* Bytes allocated */
 
+    WT_COMPILED_BOUND *compiled_bound; /* Precompiled configurations */
+
     /*
      * Operations acting on handles.
      *
diff --git a/src/include/wiredtiger.in b/src/include/wiredtiger.in
index 3d0fbcd16..fbf42772f 100644
--- a/src/include/wiredtiger.in
+++ b/src/include/wiredtiger.in
@@ -1095,6 +1095,17 @@ struct __wt_session {
 	int __F(alter)(WT_SESSION *session,
 	    const char *name, const char *config);
 
+	/*!
+	 * Bind values for a compiled configuration.
+	 *
+	 * @param session the session handle
+	 * @param compiled a string returned from WT_CONNECTION::compile_configuration
+	 * @param bound the returned configuration string
+	 * @errors
+	 */
+	int __F(bind_configuration)(WT_SESSION *session,
+	    const char *compiled, const char **bound, ...);
+
 	/*!
 	 * Create a table, column group, index or file.
 	 *
@@ -2422,6 +2433,26 @@ struct __wt_connection {
 	 */
 	int __F(is_new)(WT_CONNECTION *connection);
 
+	/*!
+	 * Compile a configuration string to be used with an API.  The string returned by this
+         * method can be used with the indicated API call as its configuration argument.
+         * Precompiled strings should be used where configuration parsing has proved to be a
+         * performance bottleneck. The lifetime of a configuration string ends when the connection
+         * is closed. The number of compilation strings that can be made is limited by
+         * the \c compile_configuration_count configuration in ::wiredtiger_open .
+         *
+         * Configuration strings containing '%d' or '%s' can have values bound, see
+         * WT_SESSION::bind_configuration.
+	 *
+	 * @param connection the connection handle
+	 * @param method the API to the configuration string applies to, e.g.
+         * WT_SESSION.open_cursor
+	 * @param str the configuration string to compile
+	 * @param compiled the returned configuration string
+	 */
+	int __F(compile_configuration)(WT_CONNECTION *connection, const char *method,
+            const char *str, const char **compiled);
+
 	/*!
 	 * @name Session handles
 	 * @{
@@ -2853,6 +2884,8 @@ struct __wt_connection {
  * version set in the \c release setting.  Has no effect if creating the database., a string;
  * default empty.}
  * @config{ ),,}
+ * @config{compile_configuration_count, limit to number of strings that compile_configuration can
+ * create., a string; default \c 100.}
  * @config{config_base, write the base configuration file if creating the database.  If \c false in
  * the config passed directly to ::wiredtiger_open\, will ignore any existing base configuration
  * file in addition to not creating one.  See @ref config_base for more information., a boolean
@@ -3539,7 +3572,7 @@ struct __wt_config_item {
 	int64_t val;
 
 	/*! Permitted values of the \c type field. */
-	enum {
+	enum __wt_config_item_enum {
 		/*! A string value with quotes stripped. */
 		WT_CONFIG_ITEM_STRING,
 		/*! A boolean literal ("true" or "false"). */
diff --git a/src/include/wt_internal.h b/src/include/wt_internal.h
index f5871dbf7..b897c53e4 100644
--- a/src/include/wt_internal.h
+++ b/src/include/wt_internal.h
@@ -127,6 +127,14 @@ struct __wt_colgroup;
 typedef struct __wt_colgroup WT_COLGROUP;
 struct __wt_compact_state;
 typedef struct __wt_compact_state WT_COMPACT_STATE;
+struct __wt_compiled;
+typedef struct __wt_compiled WT_COMPILED;
+struct __wt_compiled_bind_desc;
+typedef struct __wt_compiled_bind_desc WT_COMPILED_BIND_DESC;
+struct __wt_compiled_bound;
+typedef struct __wt_compiled_bound WT_COMPILED_BOUND;
+struct __wt_compiled_value;
+typedef struct __wt_compiled_value WT_COMPILED_VALUE;
 struct __wt_condvar;
 typedef struct __wt_condvar WT_CONDVAR;
 struct __wt_config;
@@ -423,6 +431,7 @@ typedef uint64_t wt_timestamp_t;
 #include "capacity.h"
 #include "cell.h"
 #include "compact.h"
+#include "compiled.h"
 #include "config.h"
 #include "cursor.h"
 #include "dlh.h"
@@ -467,6 +476,7 @@ typedef uint64_t wt_timestamp_t;
 #include "btree_inline.h" /* required by cursor_inline.h */
 #include "btree_cmp_inline.h"
 #include "column_inline.h"
+#include "compiled_inline.h"
 #include "cursor_inline.h"
 #include "log_inline.h"
 #include "os_fhandle_inline.h"
diff --git a/src/session/session_api.c b/src/session/session_api.c
index 31caa1d4f..b2401db86 100644
--- a/src/session/session_api.c
+++ b/src/session/session_api.c
@@ -183,6 +183,9 @@ __wt_session_release_resources(WT_SESSION_IMPL *session)
     /* Stashed memory. */
     __wt_stash_discard(session);
 
+    /* Compiled cleanup. */
+    __wt_compiled_bound_free(session);
+
     /* Scratch buffers and error memory. */
     if (done) {
         __wt_scr_discard(session);
@@ -795,6 +798,28 @@ err:
     API_END_RET(session, ret);
 }
 
+/*
+ * __session_bind_configuration --
+ *     WT_SESSION->bind_configuration method.
+ */
+static int
+__session_bind_configuration(WT_SESSION *wt_session, const char *compiled, const char **bound, ...)
+{
+    WT_DECL_RET;
+    WT_SESSION_IMPL *session;
+    va_list ap;
+
+    session = (WT_SESSION_IMPL *)wt_session;
+    SESSION_API_CALL_PREPARE_ALLOWED_NOCONF(session, bind_configuration);
+
+    va_start(ap, bound);
+    ret = __wt_compiled_bind(session, compiled, bound, ap);
+    va_end(ap);
+
+err:
+    API_END_RET(session, ret);
+}
+
 /*
  * __wt_session_create --
  *     Internal version of WT_SESSION::create.
@@ -2008,8 +2033,8 @@ __open_session(WT_CONNECTION_IMPL *conn, WT_EVENT_HANDLER *event_handler, const
 {
     static const WT_SESSION
       stds = {NULL, NULL, __session_close, __session_reconfigure, __session_flush_tier,
-        __wt_session_strerror, __session_open_cursor, __session_alter, __session_create,
-        __wt_session_compact, __session_drop, __session_join, __session_log_flush,
+        __wt_session_strerror, __session_open_cursor, __session_alter, __session_bind_configuration,
+        __session_create, __wt_session_compact, __session_drop, __session_join, __session_log_flush,
         __session_log_printf, __session_rename, __session_reset, __session_salvage,
         __session_truncate, __session_upgrade, __session_verify, __session_begin_transaction,
         __session_commit_transaction, __session_prepare_transaction, __session_reset_snapshot,
@@ -2018,11 +2043,11 @@ __open_session(WT_CONNECTION_IMPL *conn, WT_EVENT_HANDLER *event_handler, const
         __wt_session_breakpoint},
       stds_readonly = {NULL, NULL, __session_close, __session_reconfigure, __session_flush_tier,
         __wt_session_strerror, __session_open_cursor, __session_alter_readonly,
-        __session_create_readonly, __wt_session_compact_readonly, __session_drop_readonly,
-        __session_join, __session_log_flush_readonly, __session_log_printf_readonly,
-        __session_rename_readonly, __session_reset, __session_salvage_readonly,
-        __session_truncate_readonly, __session_upgrade_readonly, __session_verify,
-        __session_begin_transaction, __session_commit_transaction,
+        __session_bind_configuration, __session_create_readonly, __wt_session_compact_readonly,
+        __session_drop_readonly, __session_join, __session_log_flush_readonly,
+        __session_log_printf_readonly, __session_rename_readonly, __session_reset,
+        __session_salvage_readonly, __session_truncate_readonly, __session_upgrade_readonly,
+        __session_verify, __session_begin_transaction, __session_commit_transaction,
         __session_prepare_transaction_readonly, __session_reset_snapshot,
         __session_rollback_transaction, __session_timestamp_transaction, __session_query_timestamp,
         __session_checkpoint_readonly, __session_transaction_pinned_range,
diff --git a/src/txn/txn_timestamp.c b/src/txn/txn_timestamp.c
index e818d98b1..a2d94b435 100644
--- a/src/txn/txn_timestamp.c
+++ b/src/txn/txn_timestamp.c
@@ -843,14 +843,12 @@ __wt_txn_set_read_timestamp(WT_SESSION_IMPL *session, wt_timestamp_t read_ts)
 int
 __wt_txn_set_timestamp(WT_SESSION_IMPL *session, const char *cfg[])
 {
-    WT_CONFIG cparser;
-    WT_CONFIG_ITEM ckey, cval;
+    WT_CONFIG_ITEM cval;
     WT_DECL_RET;
-    wt_timestamp_t commit_ts, durable_ts, prepare_ts, read_ts;
+    wt_timestamp_t ts;
     bool set_ts;
 
     set_ts = false;
-    commit_ts = durable_ts = prepare_ts = read_ts = 0;
 
     WT_TRET(__wt_txn_context_check(session, true));
 
@@ -861,50 +859,58 @@ __wt_txn_set_timestamp(WT_SESSION_IMPL *session, const char *cfg[])
     if (cfg == NULL || cfg[0] == NULL || cfg[1] == NULL)
         return (0);
 
-    /*
-     * We take a shortcut in parsing that works because we're only given a base configuration and a
-     * user configuration.
-     */
-    WT_ASSERT(session, cfg[0] != NULL && cfg[1] != NULL && cfg[2] == NULL);
-    __wt_config_init(session, &cparser, cfg[1]);
-    while ((ret = __wt_config_next(&cparser, &ckey, &cval)) == 0) {
-        WT_ASSERT(session, ckey.str != NULL);
-        if (WT_STRING_MATCH("commit_timestamp", ckey.str, ckey.len)) {
-            WT_RET(__wt_txn_parse_timestamp(session, "commit", &commit_ts, &cval));
-            set_ts = true;
-        } else if (WT_STRING_MATCH("durable_timestamp", ckey.str, ckey.len)) {
-            WT_RET(__wt_txn_parse_timestamp(session, "durable", &durable_ts, &cval));
-            set_ts = true;
-        } else if (WT_STRING_MATCH("prepare_timestamp", ckey.str, ckey.len)) {
-            WT_RET(__wt_txn_parse_timestamp(session, "prepare", &prepare_ts, &cval));
-            set_ts = true;
-        } else if (WT_STRING_MATCH("read_timestamp", ckey.str, ckey.len)) {
-            WT_RET(__wt_txn_parse_timestamp(session, "durable", &read_ts, &cval));
-            set_ts = true;
-        }
-    }
-    WT_RET_NOTFOUND_OK(ret);
-
     /* Look for a commit timestamp. */
-    if (commit_ts != 0)
-        WT_RET(__wt_txn_set_commit_timestamp(session, commit_ts));
+    ret = __wt_config_gets_def_api(session, cfg,
+      WT_API_SESSION_TIMESTAMP_TRANSACTION_COMMIT_TIMESTAMP, "commit_timestamp", 0, &cval);
+    WT_RET_NOTFOUND_OK(ret);
+    if (ret == 0 && cval.len != 0) {
+        if (cval.type == WT_CONFIG_ITEM_NUM)
+            ts = (uint64_t)cval.val;
+        else
+            WT_RET(__wt_txn_parse_timestamp(session, "commit", &ts, &cval));
+        WT_RET(__wt_txn_set_commit_timestamp(session, ts));
+        set_ts = true;
+    }
 
     /*
      * Look for a durable timestamp. Durable timestamp should be set only after setting the commit
      * timestamp.
      */
-    if (durable_ts != 0)
-        WT_RET(__wt_txn_set_durable_timestamp(session, durable_ts));
+    ret = __wt_config_gets_def_api(session, cfg,
+      WT_API_SESSION_TIMESTAMP_TRANSACTION_DURABLE_TIMESTAMP, "durable_timestamp", 0, &cval);
+    WT_RET_NOTFOUND_OK(ret);
+    if (ret == 0 && cval.len != 0) {
+        if (cval.type == WT_CONFIG_ITEM_NUM)
+            ts = (uint64_t)cval.val;
+        else
+            WT_RET(__wt_txn_parse_timestamp(session, "durable", &ts, &cval));
+        WT_RET(__wt_txn_set_durable_timestamp(session, ts));
+    }
+
     __wt_txn_publish_durable_timestamp(session);
 
     /* Look for a read timestamp. */
-    if (read_ts != 0)
-        WT_RET(__wt_txn_set_read_timestamp(session, read_ts));
+    WT_RET(__wt_config_gets_def_api(session, cfg,
+      WT_API_SESSION_TIMESTAMP_TRANSACTION_READ_TIMESTAMP, "read_timestamp", 0, &cval));
+    if (ret == 0 && cval.len != 0) {
+        if (cval.type == WT_CONFIG_ITEM_NUM)
+            ts = (uint64_t)cval.val;
+        else
+            WT_RET(__wt_txn_parse_timestamp(session, "read", &ts, &cval));
+        set_ts = true;
+        WT_RET(__wt_txn_set_read_timestamp(session, ts));
+    }
 
     /* Look for a prepare timestamp. */
-    if (prepare_ts != 0)
-        WT_RET(__wt_txn_set_prepare_timestamp(session, prepare_ts));
-
+    WT_RET(__wt_config_gets_def_api(session, cfg,
+      WT_API_SESSION_TIMESTAMP_TRANSACTION_PREPARE_TIMESTAMP, "prepare_timestamp", 0, &cval));
+    if (ret == 0 && cval.len != 0) {
+        if (cval.type == WT_CONFIG_ITEM_NUM)
+            ts = (uint64_t)cval.val;
+        else
+            WT_RET(__wt_txn_parse_timestamp(session, "prepare", &ts, &cval));
+        WT_RET(__wt_txn_set_prepare_timestamp(session, ts));
+    }
     if (set_ts)
         WT_RET(__wt_txn_ts_log(session));
 
diff --git a/test/csuite/CMakeLists.txt b/test/csuite/CMakeLists.txt
index 847e4a90a..05fcb1e9c 100644
--- a/test/csuite/CMakeLists.txt
+++ b/test/csuite/CMakeLists.txt
@@ -4,6 +4,14 @@ include(${CMAKE_SOURCE_DIR}/cmake/helpers.cmake)
 
 set(c_tests)
 
+define_c_test(
+    TARGET test_compile_config
+    SOURCES compile_config/main.c
+    DIR_NAME compile_config
+    ARGUMENTS $<TARGET_FILE:test_compile_config>
+    DEPENDS "WT_POSIX"
+)
+
 define_c_test(
     TARGET test_incr_backup
     SOURCES incr_backup/main.c
